VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CAddInManager"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
Attribute VB_Description = "Basic Tools Add-In"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses CMDS.CLS FILEHAND.CLS

''@B ManagerMembers
' IDE instance
Private rap As Application

' All commands known to add-in
Public Commands As New NCommands
' File event handler and handle
Public FileHandler As New CFileHandler
' Collections relating commands to ways of invoking commands
Public MenuItems As New NMenuItems
' Add KeystrokeItems and ToolbarItems here
''@E ManagerMembers

Const vbextAddInRemoveFail = -1

''@B ConnectAddIn
Public Sub ConnectAddIn(rapA As Application)
    Set rap = rapA
    
    ' Create initializes internal commands
    ''@B CmdCreate
    If Not Commands.Create(Me) Then GoTo Fail
    ''@E CmdCreate
    
    ' Inform IDE of file event handler, and get receipt
    ''@B ConnectFile
    If Not FileHandler.Create(Me) Then GoTo Fail
    ''@E ConnectFile
    
    ' Initialize MenuItems collection
    If Not MenuItems.Create(Me) Then GoTo Fail
    
    ' Initialize hard-coded menu items (ignore fail)
    ''@B Customize
    Call MenuItems.Add(sItemCustomize, sCmdCustomize)
    ''@E Customize
    ' Turned off in 16-bit because of crashing VB bug
#If Win32 Then
    Call MenuItems.Add(sItemLogFile, sCmdLogFile, Commands.LogFile)
#End If
    ''@B ShowInfo
    Call MenuItems.Add(sItemShowInfo, sCmdShowInfo)
    ''@E ShowInfo
    
    ' Do same with keys and toolbars
    
    ' Report connection as event
    Commands.LogEntry "Connect: ", "Program", rap.FullName
    Exit Sub
Fail:
    On Error Resume Next
    DisconnectAddIn vbextAddInRemoveFail
    MsgBox "Could not connect add-in"
End Sub
''@E ConnectAddIn

''@B DisconnectAddIn
Public Sub DisconnectAddIn(ordReason As Integer)
    
    ' Log disconnect
    Commands.LogEntry "Disconnect: ", "Reason", _
        Switch(ordReason = vbextAddInRemoveExit, _
               "Visual Basic IDE closing", _
               ordReason = vbextAddInRemoveUser, _
               "Unchecked in AddIn Manager", _
               ordReason = vbextAddInRemoveFail, "Connect failed")

    ' Clean up hierarchy objects
    ''@B Destroy
    MenuItems.Destroy
    ''@E Destroy
    FileHandler.Destroy
    Commands.Destroy
       
End Sub
''@E DisconnectAddIn

''@B Application
Property Get Application() As Application
    Set Application = rap
End Property
''@E Application

' No parent
Property Get Parent() As Application
    Set Parent = Me
End Property

Property Get Manager() As Application
    Set Manager = Me
End Property
