Attribute VB_Name = "MAppPath"
Option Explicit

#If Win16 Then
Const ThisProgramRequires = Win32
#End If

Sub main()
    If Not HasShell Then
        MsgBox "This environment does not support App Paths"
        End
    End If
    Dim sExeSpec As String, f As Boolean
    Dim fOverRide As Boolean, fSetPath As Boolean, fRemove As Boolean
    If Command$ = sEmpty Then
        ' Query for EXE files
        f = VBGetOpenFileName(vFileName:=sExeSpec, _
                              vFlags:=cdlOFNFileMustExist Or cdlOFNHideReadOnly, _
                              vInitDir:="c:\", _
                              vFilter:="EXE Files|*.exe")
        If f = False Or sExeSpec = sEmpty Then End
    Else
        ' Parse and handle command line
        Dim sToken As String
        Const sSep = sSpace & sTab
        sToken = GetQToken(Command$, sSep)
        Do While sToken <> sEmpty
            Select Case UCase$(Left$(sToken, 2))
            Case "/O"
                fOverRide = True
            Case "/R"
                fRemove = True
            Case "/P"
                fSetPath = True
            Case Else
                If Left$(sToken, 1) = "/" Or sExeSpec <> sEmpty Then
                    MsgBox "Invalid command line" & sCrLfCrLf & _
                           "Syntax: AppPath [/O[verride]] [/R[emove]] [/P[athSet]] <fullpathspec>"
                Else
                    sExeSpec = GetFileFullSpec(sToken)
                End If
            End Select
            sToken = GetQToken(sEmpty, sSep)
        Loop
    End If
    If fRemove Then
        If RemoveAppPath(sExeSpec) = False Then
            MsgBox "Couldn't delete App Path for: " & GetFileBaseExt(sExeSpec)
        End If
        End
    End If
    Dim ret As Integer, s As String
    ' See if path already exists
    s = GetAppPath(sExeSpec)
    If s <> sEmpty And fOverRide = False Then
        ret = MsgBox("App Path set to: " & s & ".  Override?", vbYesNo)
        If ret = False Then End
    End If
    SetAppPath sExeSpec, fSetPath
End Sub
