Attribute VB_Name = "MBetter"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'' Better Basic procedures replace VB and VBA run-time procedures

' Note that these improved string conversion functions ignore
' differences between variant and string versions, dealing only
' with strings.

''@B Hex
Function Hex(ByVal i As Long, Optional vWidth As Variant) As String
    If IsMissing(vWidth) Then
        Hex = VBA.Hex$(i)
    Else
        Hex = Right$(String$(vWidth, "0") & VBA.Hex$(i), vWidth)
    End If
End Function
''@E Hex

Function Oct(ByVal i As Long, Optional vWidth As Variant) As String
    If IsMissing(vWidth) Then
        Oct = VBA.Oct$(i)
    Else
        Oct = Right$(String$(vWidth, "0") & VBA.Oct$(i), vWidth)
    End If
End Function

Function Str(ByVal i As Long, _
             Optional vWidth As Variant) As String
    If IsMissing(vWidth) Then
        Str = VBA.Str$(i)
    Else
        Str = Right$(String$(vWidth, " ") & VBA.Str$(i), vWidth)
    End If
End Function

' This Timer function is much more accurate than default, but
' actual values returned are different. Use Timer only for measuring
' relative times. Use VBA.Timer if you really need seconds since
' midnight.
''@B Timer
Function Timer() As Single
    Timer = timeGetTime / 1000!
End Function
''@E Timer

' Better version allows lists of file specs: Kill bad.txt *.jnk
''@B Kill
Function Kill(ParamArray vFiles() As Variant) As Boolean
    Dim v As Variant
    On Error Resume Next    ' One failure shouldn't stop all
    For Each v In vFiles
        VBA.Kill v
    Next
    Kill = (Err = 0)        ' Something failed, but can't say what
End Function
''@E Kill

' Activate with handle as well as name
''@B AppActivate
Sub AppActivate(vTarget As Variant, Optional vWait As Variant)
    If IsNumeric(vTarget) Then
        ' Ignore wait flag with handle
#If Win32 Then
        SetForegroundWindow vTarget
#Else
        SetActiveWindow vTarget
#End If
    Else
        VBA.AppActivate vTarget, vWait
    End If
End Sub
''@E AppActivate
'
