Attribute VB_Name = "MFileInfo"
Option Explicit
#If Win32 Then
DefLng A-Z

' Special attribute for Files function
Public Const vbStopFind As Long = -1

' Browse for folder
Type TBrowseInfo
    hwndOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Long
End Type

Declare Function SHBrowseForFolder Lib "Shell32" ( _
    lpbi As TBrowseInfo) As Long

' App Bar
Type TAppBarData
    cbSize As Long
    hWnd As Long
    uCallbackMessage As Long
    uEdge As Long
    rcLeft As Long
    rcTop As Long
    rcRight As Long
    rcBottom As Long
    lParam As Long              ' message specific
End Type

Declare Function SHAppBarMessage Lib "Shell32" ( _
    ByVal dwMessage As Long, pData As TAppBarData) As Long
   
' File Information

''@B TFileInfo
Type TFileInfo
    hIcon As Long
    iIcon As Long
    dwAttributes As Long
    szDisplayName As String * cMaxFile
    szTypeName As String * 80
End Type
''@E TFileInfo

Declare Function SHGetFileInfo Lib "Shell32" Alias "SHGetFileInfoA" ( _
    ByVal pszPath As String, _
    ByVal dwFileAttributes As Long, _
    psfi As TFileInfo, _
    ByVal cbFileInfo As Long, _
    ByVal uFlags As Long) As Long

Declare Function SHGetItemInfo Lib "Shell32" Alias "SHGetFileInfoA" ( _
    ByVal lpItem As Long, _
    ByVal dwFileAttributes As Long, _
    psfi As TFileInfo, _
    ByVal cbFileInfo As Long, _
    ByVal uFlags As Long) As Long

Public Const fiWin16Exe = &H454E
Public Const fiDosExe = &H5A4D
Public Const fiWin32Exe = &H4550
Public Const fiWin32Console = &H4543

Public Const SHGFI_ICON = &H100&                        ' get icon
Public Const SHGFI_DISPLAYNAME = &H200&                 ' get display name
Public Const SHGFI_TYPENAME = &H400&                    ' get type name
Public Const SHGFI_ATTRIBUTES = &H800&                  ' get attributes
Public Const SHGFI_ICONLOCATION = &H1000&               ' get icon location
Public Const SHGFI_EXETYPE = &H2000&                    ' return exe type
Public Const SHGFI_SYSICONINDEX = &H4000&               ' get system icon index
Public Const SHGFI_LINKOVERLAY = &H8000&                ' put a link overlay on icon
Public Const SHGFI_SELECTED = &H10000                   ' show icon in selected state
Public Const SHGFI_LARGEICON = &H0&                     ' get large icon
Public Const SHGFI_SMALLICON = &H1&                     ' get small icon
Public Const SHGFI_OPENICON = &H2&                      ' get open icon
Public Const SHGFI_SHELLICONSIZE = &H4&                 ' get shell size icon
Public Const SHGFI_PIDL = &H8&                          ' pszPath is a pidl
Public Const SHGFI_USEFILEATTRIBUTES = &H10&            ' use passed dwFileAttribute

''@B GetFileItemInfo
Function GetFileItemInfo(vFileItem As Variant, fi As TFileInfo, _
                         ByVal afOption As Long, Optional vAttr As Variant) As Long
    Dim f As Long
    If VarType(vFileItem) = vbString Then
        afOption = afOption And (Not SHGFI_PIDL)
        f = GetFileInfo(CStr(vFileItem), fi, afOption, vAttr)
    Else
        afOption = afOption Or SHGFI_PIDL
        f = GetItemInfo(CLng(vFileItem), fi, afOption)
    End If
    GetFileItemInfo = f
    
End Function
''@E GetFileItemInfo

''@B GetFileInfo
Function GetFileInfo(sFile As String, fi As TFileInfo, _
                     ByVal afOption As Long, _
                     Optional vAttr As Variant) As Long
    If IsMissing(vAttr) Then vAttr = 0
    afOption = afOption And (Not SHGFI_PIDL)
    GetFileInfo = SHGetFileInfo(sFile, vAttr, fi, Len(fi), afOption)
End Function
''@E GetFileInfo

''@B GetItemInfo
Function GetItemInfo(iItem As Long, fi As TFileInfo, _
                     ByVal afOpt As Long) As Long
    ' Get item ID pointer, but don't use attributes
    afOpt = afOpt Or SHGFI_PIDL And (Not SHGFI_USEFILEATTRIBUTES)
    Dim objMalloc As IMalloc, pItemID As Long
    SHGetMalloc objMalloc
    ' Getting special folder can fail, causing a Basic error
    On Error Resume Next
    SHGetSpecialFolderLocation 0, iItem, pItemID
    If Err Then Exit Function
    GetItemInfo = SHGetItemInfo(pItemID, 0, fi, Len(fi), afOpt)
    objMalloc.Free pItemID
    Set objMalloc = Nothing
End Function
''@E GetItemInfo

''@B Files
Function Files(hFiles As Long, fi As CFileInfo, _
               ByVal sSpec As String, _
               Optional vInAttr As Variant) As String
    Dim fd As TFindData, sName As String, f As Boolean
    Dim sPath As String, afAttr As Long
    If Not IsMissing(vInAttr) Then afAttr = vInAttr ' Else 0 (vbNormal)
    
    ' Stop finding and close handle early
    If afAttr = vbStopFind Then
        f = FindClose(hFiles)
        hFiles = 0: Exit Function
    End If
    f = True
    Do
        ' Get first or next file
        If hFiles = 0 Then
            hFiles = FindFirstFile(sSpec, fd)
        Else
            f = FindNextFile(hFiles, fd)
        End If
        If (f = False Or hFiles = INVALID_HANDLE_VALUE) Then
            If Err.LastDllError = ERROR_NO_MORE_FILES Then
                f = FindClose(hFiles)
            End If
            hFiles = 0: Exit Function
        End If
        ' Keep looping until something matches attributes
    Loop While (afAttr <> vbNormal) And _
               ((afAttr And fd.dwFileAttributes) = 0)
    ' Get file data and return through reference
    sPath = GetFileDir(sSpec)
    sName = StrZToStr(fd.cFileName)
    fi.CreateFile sPath & sName, _
                  fd.dwFileAttributes, fd.nFileSizeLow, _
                  SysToVBTime(fd.ftLastWriteTime), _
                  SysToVBTime(fd.ftLastAccessTime), _
                  SysToVBTime(fd.ftCreationTime)
    Files = sName
End Function
''@E Files

' Recent document list

Sub AddToRecentDocs(sDoc As String)
    SHAddToRecentDocs SHARD_PATH, sDoc
End Sub

Sub ClearRecentDocs()
    SHAddToRecentDocs SHARD_PATH, sNullStr
End Sub

Function BrowseForFolder(Optional vRoot As Variant, _
                         Optional vOptions As Variant, _
                         Optional vTitle As Variant, _
                         Optional vDisplayName As Variant, _
                         Optional vOwner As Variant) As String

    Dim bi As TBrowseInfo
    If Not IsMissing(vOwner) Then bi.hwndOwner = vOwner
    bi.pszDisplayName = String$(cMaxPath, 0)
    If Not IsMissing(vRoot) Then
        bi.pidlRoot = vRoot
    Else
        bi.pidlRoot = CSIDL_DRIVES
    End If
    If Not IsMissing(vTitle) Then bi.lpszTitle = vTitle
    If Not IsMissing(vOptions) Then bi.ulFlags = vOptions
    ' bi.lpfn = 0
    ' bi.lParam = 0
    ' bi.iImage
    Dim pidl As Long, sPath As String
    pidl = SHBrowseForFolder(bi)
    If Not IsMissing(vDisplayName) Then vDisplayName = StrZToStr(bi.pszDisplayName)
    sPath = String$(cMaxPath, 0)
    SHGetPathFromIDList pidl, sPath
    BrowseForFolder = StrZToStr(sPath)
    
End Function

#End If

