Attribute VB_Name = "MFun"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

' Uses WINTYPE.BAS, GDITOOL.BAS

Const PI = 3.1415

''@B BmpSpiral
Sub BmpSpiral(picSrc As Picture, cvsDst As Object)
With cvsDst
    ' Calculate sizes
    Dim dxSrc, dySrc, dxDst, dyDst ' As SysInt
    dxSrc = .ScaleX(picSrc.Width): dySrc = .ScaleY(picSrc.Height)
    dxDst = .ScaleWidth: dyDst = .ScaleHeight
    ' Set defaults (play with these numbers for different effects)
    Dim xInc, yInc, xSize, ySize, x, y ' As SysInt
    xInc = CInt(dxSrc * 0.01): yInc = CInt(dySrc * 0.01)
    xSize = CInt(dxSrc * 0.1): ySize = CInt(dySrc * 0.1)
    Dim radCur As Single, degCur As Integer, angInc As Integer
    degCur = 0: angInc = 55
    ' Start in center
    x = (dxDst \ 2) - (dxSrc \ 2): y = (dyDst \ 2) - (dySrc \ 2)
    
    ' Spiral until off destination
    Do
        ' Draw at current position
        .PaintPicture picSrc, x, y, , , , , , , vbSrcAnd
        ' Calculate angle in radians
        radCur = (degCur - 90) * (PI / 180)
        ' Calculate next x and y
        x = x + (xSize * Cos(radCur))
        y = y + (ySize * Sin(radCur))
        ' Widen spiral
        xSize = xSize + xInc: ySize = ySize + yInc + 1
        ' Turn angle
        degCur = (degCur + angInc) Mod 360
    Loop While (x > 0) And (x + dxSrc < dxDst - dxSrc) And _
               (y > 0) And (y + dySrc < dyDst)
End With
End Sub
''@E BmpSpiral

''@B SpiralBmp
Sub SpiralBmp(picSrc As Picture, cvsDst As Object, _
              ByVal xOff, ByVal yOff)
With cvsDst
    Dim xLeft, xRight, yTop, yBottom ' As SysInt
    Dim dxSrc, dySrc, xSrc, ySrc ' As SysInt
    Dim xDst, yDst, xInc, yInc, x, y ' As SysInt
    ' Initialize
    dxSrc = .ScaleX(picSrc.Width): dySrc = .ScaleY(picSrc.Height)
    xInc = dxSrc / 20: yInc = dySrc / 20
    xLeft = 0: yTop = 0:
    xRight = dxSrc - xInc: yBottom = dySrc - yInc

    ' Draw each side
    Do While (xLeft <= xRight) And (yTop <= yBottom)
        ' Top
        For x = xLeft To xRight Step xInc
            .PaintPicture picSrc, x + xOff, y + yOff, xInc, yInc, _
                x, y, xInc, yInc, vbSrcCopy
        Next
        x = x - xInc: yTop = yTop + yInc
        ' Right
        For y = yTop To yBottom Step yInc
            .PaintPicture picSrc, x + xOff, y + yOff, xInc, yInc, _
                x, y, xInc, yInc, vbSrcCopy
        Next
        y = y - yInc: xRight = x - xInc
        ' Bottom
        For x = xRight To xLeft Step -xInc
            .PaintPicture picSrc, x + xOff, y + yOff, xInc, yInc, _
                x, y, xInc, yInc, vbSrcCopy
        Next
        x = x + xInc: yBottom = y - yInc
        ' Left
        For y = yBottom To yTop Step -yInc
            .PaintPicture picSrc, x + xOff, y + yOff, xInc, yInc, _
                x, y, xInc, yInc, vbSrcCopy
        Next
        y = y + yInc: xLeft = xLeft + xInc
    Loop
End With
End Sub
''@E SpiralBmp

''@B Star
Sub Star(ByVal x, ByVal y, ByVal dxyRadius, clrBorder As Long, _
         clrOut As Long, clrIn As Long, cvsDst As Object)
With cvsDst
    ' Start is 144 degrees (converted to radians)
    Const radStar As Double = 144 * PI / 180
    
    ' Calculate each point
    Dim ptPoly(1 To 5) As TPoint, i As Integer
    For i = 1 To 5
        ptPoly(i).x = x + (Cos(i * radStar) * dxyRadius)
        ptPoly(i).y = y + (Sin(i * radStar) * dxyRadius)
    Next
    
    ' Set colors and style for star
    .ForeColor = clrBorder    ' SetTextColor
    .FillColor = clrOut       ' CreateSolidBrush
    .FillStyle = vbSolid      ' More CreateSolidBrush
    Call VBPolygon(.hDC, ptPoly())
    
    ' Set color for center
    .FillColor = clrIn        ' CreateSolidBrush
    Call VBFloodFill(.hDC, x, y, .ForeColor)
End With
End Sub
''@E Star

''@B Fade
Sub Fade(obj As Object, Optional vRed As Variant, _
         Optional vGreen As Variant, Optional vBlue As Variant, _
         Optional vVert As Variant, Optional vHoriz As Variant, _
         Optional vLightToDark As Variant)
    ' Give all optional arguments default values
    If IsMissing(vRed) Then vRed = False
    If IsMissing(vBlue) Then vBlue = False
    If IsMissing(vGreen) Then vGreen = False
    If Not vRed And Not vGreen Then vBlue = True ' Color required
    If IsMissing(vVert) Then vVert = False
    If IsMissing(vHoriz) Then vHoriz = False: vVert = True
    If IsMissing(vLightToDark) Then vLightToDark = True

    ' Trap errors
    On Error Resume Next
    With obj
        ' Save properties
        Dim fAutoRedraw As Boolean, ordDrawStyle As Integer
        Dim ordDrawMode As Integer, iDrawWidth As Integer
        Dim ordScaleMode As Integer
        Dim rScaleWidth As Single, rScaleHeight As Single
        fAutoRedraw = .AutoRedraw: iDrawWidth = .DrawWidth
        ordDrawStyle = .DrawStyle: ordDrawMode = .DrawMode
        rScaleWidth = .ScaleWidth: rScaleHeight = .ScaleHeight
        ordScaleMode = .ScaleMode
        ' Err set if object lacks one of previous properties
        If Err Then Exit Sub
        ' If you get here, object is OK (Printer lacks AutoRedraw)
        On Error GoTo 0
        fAutoRedraw = .AutoRedraw
        
        ' Set properties required for fade
        .AutoRedraw = True
        .DrawWidth = 2   ' Required for dithering
        .DrawStyle = vbInsideSolid: .DrawMode = vbCopyPen
        .ScaleMode = vbPixels
        .ScaleWidth = 256 * 2: .ScaleHeight = 256 * 2
        
        Dim clr As Long, i As Integer, x As Integer, y As Integer
        Dim iRed As Integer, iGreen As Integer, iBlue As Integer
        For i = 0 To 255
            ' Set line color
            If vLightToDark Then
                If vRed Then iRed = 255 - i
                If vBlue Then iBlue = 255 - i
                If vGreen Then iGreen = 255 - i
            Else
                If vRed Then iRed = i
                If vBlue Then iBlue = i
                If vGreen Then iGreen = i
            End If
            clr = RGB(iRed, iGreen, iBlue)
            ' Draw each line of fade
            If vVert Then
                obj.Line (0, y)-(.ScaleWidth, y + 2), clr, BF
                y = y + 2
            End If
            If vHoriz Then
                obj.Line (x, 0)-(x + 2, .ScaleHeight), clr, BF
                x = x + 2
            End If
        Next
        ' Put things back the way you found them
        .AutoRedraw = fAutoRedraw: .DrawWidth = iDrawWidth
        .DrawStyle = ordDrawStyle: .DrawMode = ordDrawMode
        .ScaleMode = ordScaleMode
        .ScaleWidth = rScaleWidth: .ScaleHeight = rScaleHeight
    End With
End Sub
''@E Fade
'


