VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NMenuItems"
Attribute VB_Creatable = False
Attribute VB_Exposed = True
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses ADDINMAN.CLS ITEMHAND.CLS

Private menus As New Collection

Private rman As CAddInManager
Private rap As Application

Const cMaxEntries = 100

Function Create(rmanA As CAddInManager) As Boolean
    On Error GoTo CreateFail
    Set rman = rmanA
    Set rap = rman.Application
        ' Initialize menu items from settings
    If Not AddSettings Then GoTo CreateFail
    Create = True
CreateFail:
    
End Function

''@B Destroy
Sub Destroy()
    On Error Resume Next
    Dim v As Variant
    For Each v In menus
        ' Remove from menu collection
        Remove v.Name, vKeep:=True
    Next
End Sub
''@E Destroy

Property Get Application() As Application
    Set Application = rap
End Property

Property Get Parent() As CAddInManager
    Set Parent = rman
End Property

Property Get Manager() As CAddInManager
    Set Manager = rman
End Property

''@B Add
Function Add(sCaption As String, sCmd As String, _
             Optional vChecked As Variant) As Boolean
    Dim ritem As CItemHandler, f As Boolean
    On Error GoTo AddFail
    ' Create menu handler object
    Set ritem = New CItemHandler
    If IsMissing(vChecked) Then vChecked = False
    f = ritem.Create(Me, sCaption, sCmd, vChecked)
    If f = False Then GoTo AddFail
    ' Put in collection indexed by command name
    menus.Add ritem, sCmd
    Add = True
AddFail:
End Function
''@E Add

''@B AddKeep
Function AddKeep(sCaption As String, sCmd As String, _
                 Optional vChecked As Variant) As Boolean
    AddKeep = Add(sCaption, sCmd, vChecked)
    ' Register if not already registered
    If GetSetting(App.ExeName, sMenuSection, sCmd, sEmpty) = sEmpty Then
        SaveSetting App.ExeName, sMenuSection, sCmd, _
                    sCaption & sComma & vChecked
    End If
End Function
''@E AddKeep

Function AddSettings() As Boolean
    AddSettings = True  ' Assume success
    Dim sCmd As String, sCaption As String, fChecked As Boolean
    
    ' Retrieve all settings into 2D array of setting names and values
    Dim va As Variant, i As Integer
    va = GetAllSettings(App.ExeName, sMenuSection)
    ' No menu items registered
    ' Note: You must use "IsEmpty(va)" rather than more intuitive "va = Empty"
    If IsEmpty(va) Then Exit Function
    ' Process each setting
    For i = LBound(va, 1) To UBound(va, 1)
        sCmd = va(i, 0)
        sCaption = va(i, 1)
        sCaption = GetToken(sCaption, sComma)
        fChecked = GetToken(sEmpty, sComma)
        If Not Add(sCaption, sCmd, fChecked) Then
            AddSettings = False
            Exit Function
        End If
    Next

End Function

''@B Remove
Sub Remove(sName As String, Optional vKeep As Variant)
    ' Disconnect and remove from IDE menu
    menus.Item(sName).Destroy
    ' Remove from internal collection
    menus.Remove sName
    If IsMissing(vKeep) Then vKeep = False
    ' Unregister
    If Not vKeep Then
        DeleteSetting App.ExeName, sMenuSection, sName
    End If
End Sub
''@E Remove

Property Get Count() As Integer
    Count = menus.Count
End Property

Function Item(v As Variant) As CItemHandler
    'On Error Resume Next
    Set Item = menus(v)
    ' Set to nothing on error
End Function

Function Items() As Collection
    Set Items = menus
End Function
