Attribute VB_Name = "MRegistry"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

''@B sAppPath
Const sAppPath = "SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths"
''@E sAppPath

Function GetRegValue(hKeyRoot As Long, sKey As String, _
                     sSubKey As String, sVal As String) As Boolean
    Dim s As String, c As Long, hKey ' As SysInt
    If RegOpenKey(hKeyRoot, sKey, hKey) <> 0 Then Exit Function
    If RegQueryValue(hKey, sSubKey, s, c) <> 0 Then
        If c = 0 Then Exit Function
        s = String(c - 1, 0)
        If RegQueryValue(hKey, sSubKey, s, c) <> 0 Then Exit Function
    End If
    RegCloseKey hKey
    sVal = s
    GetRegValue = True
End Function

#If Win32 Then
Function GetRegNameStr(hKeyRoot As Long, sKey As String, _
                       sValue As String, sVal As String) As Boolean
    Dim f As Long, c As Long, iType As Long, s As String, hKey ' As SysInt
    If RegOpenKey(hKeyRoot, sKey, hKey) <> 0 Then Exit Function
    f = RegQueryValueExStr(hKey, sValue, pNull, iType, sNullStr, c)
    If (f = 0) And (c <> 0) And (iType = REG_SZ) Then
        s = String$(c - 1, 0)
        f = RegQueryValueExStr(hKey, sValue, pNull, REG_SZ, s, c)
    End If
    RegCloseKey hKey
    If f Or (c = 0) Then Exit Function
    sVal = StrZToStr(s)
    GetRegNameStr = True
End Function

Function GetRegNameBytes(hKeyRoot As Long, sKey As String, _
                         sValue As String, ab() As Byte) As Boolean
    Dim f As Long, iType As Long, c As Long, hKey ' As SysInt
    If RegOpenKey(hKeyRoot, sKey, hKey) <> 0 Then Exit Function
    f = RegQueryValueExStr(hKey, sValue, pNull, iType, sNullStr, c)
    If (f <> 0) And (c <> 0) And (iType = REG_BINARY) Then
        ReDim ab(c)
        f = RegQueryValueExByte(hKey, sValue, pNull, iType, ab(0), c)
    End If
    RegCloseKey hKey
    If f Or (c = 0) Then Exit Function
    GetRegNameBytes = True
End Function

Function GetRegNameInt(hKeyRoot As Long, sKey As String, _
                       sValue As String, iVal As Long) As Boolean
    Dim f As Long, c As Long, iType As Long, hKey ' As SysInt
    If RegOpenKey(hKeyRoot, sKey, hKey) <> 0 Then Exit Function
    f = RegQueryValueExStr(hKey, sValue, pNull, iType, sNullStr, c)
    If f = 0 Then
        Select Case iType
        Case REG_DWORD
            f = RegQueryValueExInt(hKey, sValue, pNull, iType, iVal, c)
            If f = 0 Then GetRegNameInt = True
        Case REG_SZ
            Dim s As String
            s = String(c - 1, 0)
            f = RegQueryValueExStr(hKey, sValue, pNull, iType, s, c)
            If f = 0 Then iVal = Val(s): GetRegNameInt = True
        End Select
    End If
    RegCloseKey hKey
End Function
#End If

Function DeleteRegKey(hKeyRoot As Long, sKey As String) As Boolean
    DeleteRegKey = (RegDeleteKey(hKeyRoot, sKey) = 0)
End Function

Function DeleteRegKeyAll(hKeyRoot As Long, sKey As String) As Boolean
#If Win32 Then
    Dim e As Long, sKeyT As String, hSubKey As Long
    
    ' Assume success
    DeleteRegKeyAll = True
    
    ' Try to delete whole thing--always works for Win95, but fails on
    ' keys with subkeys in WinNT
    e = RegDeleteKey(hKeyRoot, sKey)
    If e = ERROR_SUCCESS Then Exit Function
    e = RegOpenKeyEx(hKeyRoot, sKey, 0, KEY_ALL_ACCESS, hSubKey)
    If e <> ERROR_SUCCESS Then DeleteRegKeyAll = False: Exit Function
    e = ERROR_SUCCESS
    Do While e = ERROR_SUCCESS
        sKeyT = String$(cMaxPath, 0)
        e = RegEnumKey(hSubKey, 0, sKeyT, cMaxPath)
        sKeyT = StrZToStr(sKeyT)
        If e = ERROR_SUCCESS Then e = DeleteRegKeyAll(hSubKey, sKeyT)
    Loop
    ' Try to delete root again
    DeleteRegKeyAll = (RegDeleteKey(hKeyRoot, sKey) = ERROR_SUCCESS)
    
#Else
    ' DeleteRegKey deletes all for 16-bit
    DeleteRegKeyAll = DeleteRegKey(hKeyRoot, sKey)
#End If
    
End Function

Function SetRegValue(hKeyRoot As Long, sKey As String, _
                     sSubKey As String, sVal As String) As Boolean
    Dim hKey ' As SysInt
    If RegCreateKey(hKeyRoot, sKey, hKey) <> 0 Then Exit Function
    SetRegValue = (RegSetValue(hKey, sSubKey, REG_SZ, sVal, Len(sVal)) = 0)
    RegCloseKey hKey
End Function

''@B SetRegNameStr
#If Win32 Then
Function SetRegNameStr(hKeyRoot As Long, sKey As String, _
                       sName As String, sVal As String) As Boolean
    Dim hKey As Long
    If RegCreateKey(hKeyRoot, sKey, hKey) <> 0 Then Exit Function
    SetRegNameStr = (RegSetValueExStr(hKey, sName, 0&, REG_SZ, _
                                      sVal, Len(sVal)) = 0)
    RegCloseKey hKey
End Function
''@E SetRegNameStr

Function SetRegNameInt(hKeyRoot As Long, sKey As String, _
                       sName As String, iVal As Long) As Boolean
    Dim hKey As Long
    If RegCreateKey(hKeyRoot, sKey, hKey) <> 0 Then Exit Function
    SetRegNameInt = (RegSetValueExInt(hKey, sName, pNull, REG_DWORD, _
                                      iVal, 4) = 0)
    RegCloseKey hKey
End Function

Function SetRegNameBytes(hKeyRoot As Long, sKey As String, _
                         sName As String, abVal() As Byte) As Boolean
    Dim hKey As Long, cVal As Long
    If RegCreateKey(hKeyRoot, sKey, hKey) <> 0 Then Exit Function
    cVal = UBound(abVal) - LBound(abVal) + 1
    SetRegNameBytes = (RegSetValueEx(hKey, sName, 0&, REG_BINARY, _
                                     abVal(0), cVal) = 0)
    RegCloseKey hKey
End Function
#End If

#If Win32 Then
Function GetAppPath(sExe As String) As String
    Dim s As String, f As Boolean
    f = GetRegValue(HKEY_LOCAL_MACHINE, sAppPath, sExe, s)
    If f Then GetAppPath = s ' Else sEmpty
End Function

''@B SetAppPath
Function SetAppPath(sExeSpec As String, _
                    fSetPath As Boolean) As Boolean
    Dim sExeName As String
    sExeName = GetFileBaseExt(sExeSpec)
    If SetRegValue(HKEY_LOCAL_MACHINE, _
                   sAppPath, sExeName, sExeSpec) Then
        ' Success if name set regardless of path success
        SetAppPath = True
    End If
    
    ' Set path subkey if requested
    If fSetPath Then
        Dim sExePath As String
        sExePath = GetFileDir(sExeSpec)
        sExePath = Left(sExePath, Len(sExePath) - 1) & ";"
        SetRegNameStr HKEY_LOCAL_MACHINE, _
                      sAppPath & "\" & sExeName, "Path", sExePath
    End If
End Function
''@E SetAppPath

Function RemoveAppPath(sExe As String) As Boolean
    RemoveAppPath = DeleteRegKey(HKEY_LOCAL_MACHINE, _
                                 sAppPath & "\" & GetFileBaseExt(sExe))
End Function
#End If

