VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CSortHelper"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private ordMode As Integer

Public HiToLo As Boolean

Property Get SortMode() As Integer
    SortMode = ordMode
End Property

Property Let SortMode(ordModeA As Integer)
    Select Case ordModeA
    Case ordSortVal, ordSortText, ordSortBin, ordSortLen
        ordMode = ordModeA
    Case Else
        ordMode = ordSortVal
    End Select
End Property

' Modify to add more sort modes
''@B CallSortCompare
Public Function Compare(v1 As Variant, v2 As Variant) As Integer
    ' Use string comparisons only on strings
    If TypeName(v1) <> "String" Then ordMode = ordSortVal
    
    Dim i As Integer
    Select Case ordMode
    ' Sort by value (same as ordSortBin for strings)
    Case ordSortVal
        If v1 < v2 Then
            i = -1
        ElseIf v1 = v2 Then
            i = 0
        Else
            i = 1
        End If
    ' Sort case-insensitive
    Case ordSortText
        i = StrComp(v1, v2, 1)
    ' Sort case-sensitive
    Case ordSortBin
        i = StrComp(v1, v2, 0)
    ' Sort by string length
    Case ordSortLen
        If Len(v1) = Len(v2) Then
            If v1 = v2 Then
                i = 0
            ElseIf v1 < v2 Then
                i = -1
            Else
                i = 1
            End If
        ElseIf Len(v1) < Len(v2) Then
            i = -1
        Else
            i = 1
        End If
    End Select
    If HiToLo Then i = -i
    Compare = i
End Function
''@E CallSortCompare

''@B Swap
Sub Swap(v1 As Variant, v2 As Variant)
    Dim vT As Variant
    vT = v1
    v1 = v2
    v2 = vT
End Sub
''@E Swap

''@B CollectionSwap
Sub CollectionSwap(n As Collection, i1 As Variant, i2 As Variant)
    Dim vT As Variant
    vT = n(i1)
    n.Add n(i2), , , i1
    n.Remove i1
    n.Add vT, , , i2
    n.Remove i2
End Sub
''@E CollectionSwap



