VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CTrayIcon"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Type TNotifyIconData
    cbSize As Long
    hWnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Private Declare Function Shell_NotifyIcon Lib "Shell32" _
    Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, _
    pnid As TNotifyIconData) As Boolean

Const NIF_MESSAGE = &H1
Const NIF_ICON = &H2
Const NIF_TIP = &H4

Const NIM_ADD = &H0
Const NIM_MODIFY = &H1
Const NIM_DELETE = &H2

Private picIcon As Picture
Private icodat As TNotifyIconData
Private iMsg As Long


Function Create(hWnd As Long, picIconA As Picture, sTip As String) As Boolean
    ' Verify that we have valid handle and icon
    If IsWindow(hWnd) = False Then Exit Function
    If picIconA.Type <> vbPicTypeIcon Then Exit Function
    ' Register a unique message based on icon handle
    iMsg = RegisterWindowMessage(Hex(picIconA.Handle))
    If iMsg = 0 Then Exit Function
    ' Fill the structure and pass to Shell_NotifyIcon
    Set picIcon = picIconA
    icodat.cbSize = Len(icodat)
    icodat.hWnd = hWnd
    icodat.uID = iMsg + 1
    icodat.uFlags = NIF_MESSAGE Or NIF_ICON Or NIF_TIP
    icodat.uCallbackMessage = iMsg
    icodat.hIcon = picIconA.Handle
    icodat.szTip = sTip & sNullChr
    If Shell_NotifyIcon(NIM_ADD, icodat) Then Create = True
End Function

Sub Destroy()
    If iMsg = 0 Then Exit Sub
    Shell_NotifyIcon NIM_DELETE, icodat
End Sub

Property Get Message() As Long
    Message = icodat.uCallbackMessage
End Property

Property Get ID() As Long
    ID = icodat.uID
End Property

Property Get Tip() As String
    Tip = StrZToStr(icodat.szTip)
End Property

Property Let Tip(sTip As String)
    icodat.szTip = sTip & sNullChr
    icodat.uFlags = NIF_TIP
    Shell_NotifyIcon NIM_MODIFY, icodat
End Property

Property Get Icon() As Picture
    Set Icon = picIcon
End Property

Property Set Icon(picIconA As Picture)
    If picIconA.Type <> vbPicTypeIcon Then Exit Property
    Set picIcon = picIconA
    icodat.hIcon = picIconA.Handle
    icodat.uFlags = NIF_ICON
    Shell_NotifyIcon NIM_MODIFY, icodat
End Property

Private Sub Class_Terminate()
    Destroy
End Sub
