 // TOOLS.C - Example DLL for Visual Basic applications.

#include "vbutil.h"
#include "tools.h"

// Return Basic pointer to thing passed by reference
// Declare Function GetRefPtr LIB "VBUTIL*" (lpVoid As Any) As Long
DWORD DLLAPI GetRefPtr( LPVOID lpVoid )
{
    return (DWORD)lpVoid;
}


// Extract Word's most significant Byte
WORD DLLAPI HiByte(WORD w)
{
   return w >> 8;
}

// Extract Word's least significant Byte
WORD DLLAPI LoByte(WORD w)
{
   return w & 0xFF;
}

// Combine two Bytes into a Word
WORD DLLAPI MakeWord(WORD bHi, WORD bLo)
{
   return ( bHi << 8 ) | ( bLo & 0xFF );
}

// Shift bits of Word right
WORD DLLAPI RShiftWord(WORD w, WORD c)
{
   return w >> c;
}

// Shift bits of Word left
WORD DLLAPI LShiftWord(WORD w, WORD c)
{
   return w << c;
}

// Extract DWord's most significant Word
WORD DLLAPI HiWord(DWORD dw)
{
   return (WORD)( dw >> 16 );
}

// Extract DWord's least significant Word
WORD DLLAPI LoWord(DWORD dw)
{
   return (WORD) ( dw & 0xFFFF );
}

// Combines two Words into DWord
DWORD DLLAPI MakeDWord(DWORD wHi, DWORD wLo)
{
   return ( wHi << 16 ) | ( wLo & 0xFFFF );
}

// Shift bits of DWord right
DWORD DLLAPI RShiftDWord(DWORD dw, unsigned c)
{
   return dw >> c;
}

// Shift bits of DWord left
DWORD DLLAPI LShiftDWord(DWORD dw, unsigned c)
{
    return dw << c;
}

// Check for file existence
short DLLAPI ExistFile(LPSTR lpFileName)
{                  
	if (lpFileName == NULL) {
		return FALSE;
	}
	return (!_access(lpFileName, 0));
}

// Called interrupt function
#if !defined(WIN32)
int DLLAPI Interrupt(WORD wInt,
					 LPDWORD pAx,
					 LPDWORD pBx,
					 LPDWORD pCx,
					 LPDWORD pDx,
					 LPDWORD pSi,
					 LPDWORD pDi
					 )
{
	union _REGS regs;
	struct _SREGS sregs;
	                       
	_segread(&sregs);                       
	regs.x.ax = (WORD)*pAx; 
	regs.x.bx = (WORD)*pBx; 
	regs.x.cx = (WORD)*pCx; 
	regs.x.dx = (WORD)*pDx; 
	regs.x.si = (WORD)*pSi; 
	regs.x.di = (WORD)*pDi; 
	if (*pBx & 0xffff0000) {
		sregs.es = (WORD)(*pBx >> 16);
	}
	if (*pDx & 0xffff0000) {
		sregs.ds = (WORD)(*pDx >> 16);
	}
	if (*pSi & 0xffff0000) {
		sregs.ds = (WORD)(*pSi >> 16);
	}
	if (*pDi & 0xffff0000) {
		sregs.es = (WORD)(*pDi >> 16);
	}
	
	_int86x(wInt, &regs, &regs, &sregs);
	
	*pAx = (DWORD)regs.x.ax;
    *pBx = ((DWORD)sregs.es << 16) | regs.x.bx;
    *pCx = (DWORD)regs.x.cx;
    *pDx = ((DWORD)sregs.ds << 16) | regs.x.dx;
	*pSi = ((DWORD)sregs.ds << 16) | regs.x.si;
	*pDi = ((DWORD)sregs.es << 16) | regs.x.di;

	return regs.x.cflag;
}
#endif // !WIN32
