// Routines to translate Unicode string arguments

#include "vbutil.h"
#include "unitran.h"

#ifdef WIN32

BSTR DLLAPI GetAFromU(BSTR sUnicode)
{
	unsigned int cb;
	BSTR sAnsi = NULL;
	if (sUnicode != NULL) {
		cb = SysStringLen(sUnicode);
		if (sAnsi = SysAllocStringByteLen(NULL, cb)) {
			WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)sUnicode, -1,
								(LPSTR)sAnsi, cb + 1, NULL, NULL);
		}
	}
	return (sAnsi);
}

BSTR DLLAPI GetUFromA(BSTR sAnsi)
{
	unsigned int cb;
	BSTR sUnicode = NULL;
	if (sAnsi != NULL) {
		cb = SysStringByteLen(sAnsi);
		if(sUnicode = SysAllocStringLen(NULL, cb)) {
			MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, (LPSTR)sAnsi, -1,
								(LPWSTR)sUnicode, cb + 1);
		}
	}
	return (sUnicode);
}

BSTR DLLAPI GetUFromSz(LPSTR sz)
{
	unsigned int cb;
	BSTR sUnicode = NULL;
	if (sz != NULL) {
		cb = lstrlen(sz);
		if (sUnicode = SysAllocStringLen(NULL, cb)) {
			MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, sz, -1,
								(LPWSTR)sUnicode, cb + 1);
		}
	}
	return (sUnicode);
}

BSTR DLLAPI ConvAFromU(BSTR sUnicode)
{
	unsigned int cb;

	if (sUnicode != NULL) {
		cb = SysStringByteLen(sUnicode);
		if (SysReAllocStringByteLen(&sUnicode, sUnicode, cb)) {
			WideCharToMultiByte(CP_ACP, 0, (LPCWSTR)sUnicode, -1,
								(LPSTR)sUnicode, cb + 1, NULL, NULL);
		}
	}
	return (sUnicode);
}

BSTR DLLAPI ConvUFromA(BSTR sAnsi)
{
	unsigned int cb;
	if (sAnsi != NULL) {
		cb = SysStringByteLen(sAnsi);
		if (SysReAllocStringLen(&sAnsi, sAnsi, cb)) {
			MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, (LPSTR)sAnsi, -1,
								(LPWSTR)sAnsi, cb + 1);
		}
	}
	return (sAnsi);
}

#endif // WIN32
