// Routines to translate Unicode string arguments

#ifndef _UNITRAN_
#define _UNITRAN_

/*

The following macros can be used in order to use the same code for
WIN16, WIN32/OAU/UNICODE and WIN32/OAU preprocessor definitions.  Strings
are declare with the corrct type (Wide or MultiByte) and are converted correctly
to support both Windows and OLE2.0 API calls.

Macros:

	sU = GetUFromA(sA)
	sA = GetAFromU(sU)
	sU = GetUFromSz(sz)
	sA = GetAFromSz(sz)
	FreeUA(s)
	s = ConvUToA(s)
	s = ConvAToU(s)

BSTR UpperCase(BSTR * psOld)
{
if 1
	BSTR sNewA = GetAFromU(*psOld);
	BSTR sNewU;
	_strupr(sNewA);
	sNewU = GetUFromA(sNewA);
	FreeUA(sNewA);
	return sNewU;
else
	BSTR sNew = GetAFromU(*psOld);
	_strupr(sNew);
	return ConvUFromA(sNew);
endif
}
*/


#ifdef WIN32

// Implemented in UNITRAN.C

BSTR DLLAPI GetAFromU(BSTR sUnicode);

BSTR DLLAPI GetUFromA(BSTR sAnsi);

BSTR DLLAPI GetUFromSz(LPSTR sz);

#define GetAFromSz(sz) (sz)

BSTR DLLAPI ConvUFromA(BSTR sAnsi);

BSTR DLLAPI ConvAFromU(BSTR sUnicode);

#define FreeUA(s)	 SysFreeString((BSTR)s)

#define SysReAllocStringByteLen(pbstr, pch, cch) \
		SysReAllocStringLen((pbstr), (pch), (((cch) % 2) ? (((cch) / 2) + 1) : ((cch) / 2)))

#else

#define GetAFromU(s) (s)

#define GetUFromA(s) (s)

#define GetAFromSz(sz) (sz)

#define ConvUFromA(s) (s)

#define ConvAFromU(s) (s)

#define FreeUA(s)	 (s)

#define SysReAllocStringByteLen(pbstr, pch, cch) \
		SysReAllocStringLen((pbstr), (pch), (cch))   

#define SysAllocStringByteLen SysAllocStringLen
#define SysStringByteLen SysStringLen


#endif // WIN32

#endif // _UNITRAN_
