 // VBUTIL.C - Example DLL for Visual Basic applications.

#include "vbutil.h"


HINSTANCE hInst;

// This function is the library entry point. It should be present 
// in any DLL you create for 16-bit Visual Basic applications. It's
// optional for 32-bit. 

#ifdef WIN32		
BOOL WINAPI LibMain(HINSTANCE hInstA, DWORD dwReason, LPVOID lpvReserved)
{
	switch (dwReason) {
	case DLL_PROCESS_ATTACH:
		// The DLL is being mapped into the process's address space

		// Do any additional 32-bit initialization here
		hInst = hInstA;
	   	break;

	case DLL_THREAD_ATTACH:
		// A thread is being created
	    break;

	case DLL_THREAD_DETACH:
		// A thread is exiting cleanly
	    break;

	case DLL_PROCESS_DETACH:
		// The DLL is being unmapped from the process's address space
		
		// Do any additional 32-bit cleanup here
		hInst = 0;
	    break;
	}

	return TRUE;
}
#else

int PASCAL LibMain(HINSTANCE hInstA, WORD wDataSeg, 
				   WORD cbHeapSize, LPSTR lpCmdLine)
{
	if (cbHeapSize != 0)
		UnlockData(0);
	hInst = hInstA;

	// Do any additional 16-bit server initialization here
	
	return hInst;
}

int FAR PASCAL WEP(int bSystemExit)
{
	// Do any additional 16-bit server cleanup here
	hInst = 0;		
	return 1;
}            
#endif

#if 0 // !defined(WIN32)
int FAR PASCAL LibMain(HANDLE hInstance, WORD wDataSeg, 
                       WORD wHeapSize, LPSTR lpszCmdLine)
{
   	hInst = hInstance;
   	if ( wHeapSize > 0 )
      	UnlockData( 0 );
   	return 1;
}

int CALLBACK WEP(int nExitType)
{
	return TRUE;
}
#endif

