Attribute VB_Name = "MWinTool"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses DEBUG.BAS UTILITY.BAS WINTYPE.BAS

Const ERROR_ALREADY_EXISTS = 183&

#If Win32 Then

''@B FindWindowByAny32
Declare Function FindWindowByAny Lib "USER32" Alias "FindWindowA" ( _
    ByVal lpClassName As Any, ByVal lpNull As Any) As Long
''@E FindWindowByAny32

Declare Function SendMessage Lib "USER32" Alias "SendMessageA" ( _
    ByVal hWnd As Long, ByVal wMsg As Long, _
    ByVal wParam As Long, ByVal lParam As Any) As Long
Declare Function SendMessageByRef Lib "USER32" Alias "SendMessageA" ( _
    ByVal hWnd As Long, ByVal wMsg As Long, _
    ByVal wParam As Long, lParam As Any) As Long

Declare Function GetWindowRect Lib "USER32" (ByVal hWnd As Long, _
    lprc As TRect) As Long
Declare Sub ClientToScreen Lib "USER32" (ByVal hWnd As Long, _
    lpPoint As TPoint)
''@B WindowFromPointXY
Declare Function WindowFromPointXY Lib "USER32" _
    Alias "WindowFromPoint" (ByVal xPoint As Long, _
    ByVal yPoint As Long) As Long
Declare Function ChildWindowFromPointXY Lib "USER32" _
    Alias "WindowFromPoint" (ByVal hWnd As Long, _
    ByVal xPoint As Long, ByVal yPoint As Long) As Long
''@E WindowFromPointXY
Declare Function WindowFromPoint Lib "USER32" _
    (ByVal pt As Any) As Long

#Else

''@B FindWindowByAny
Declare Function FindWindowByAny Lib "USER" Alias "FindWindow" ( _
    ByVal lpClassName As Any, ByVal lpWindowName As Any) As Integer
''@E FindWindowByAny
    
''@B SendMessages
Declare Function SendMessage Lib "USER" ( _
    ByVal hWnd As Integer, ByVal wMsg As Integer, _
    ByVal wParam As Integer, ByVal lParam As Any) As Long
Declare Function SendMessageByRef Lib "USER" Alias "SendMessage" ( _
    ByVal hWnd As Integer, ByVal wMsg As Integer, _
    ByVal wParam As Long, lParam As Any) As Long
''@E SendMessages

Declare Function GetWindowRect Lib "USER" (ByVal hWnd As Integer, _
    lprc As TRect) As Integer
Declare Sub ClientToScreen Lib "USER" (ByVal hWnd As Integer, _
    lpPoint As TPoint)
''@B WindowFromPointYX
Declare Function WindowFromPointYX Lib "USER" _
    Alias "WindowFromPoint" (ByVal yPoint As Integer, _
    ByVal xPoint As Integer) As Integer
''@E WindowFromPointYX
Declare Function ChildWindowFromPointYX Lib "USER" _
    Alias "WindowFromPoint" (ByVal hWnd As Integer, _
    ByVal yPoint As Integer, ByVal xPoint As Integer) As Integer

#End If

''@B SetRedraw
Sub SetRedraw(ctl As Control, f As Boolean)
    Call SendMessageAsLong(ctl.hWnd, WM_SETREDRAW, f, 0&)
End Sub
''@E SetRedraw

''@B LookupItemData
Function LookupItemData(ctl As Control, h) As Integer
    BugAssert h <> hNull
    Dim i As Integer
    LookupItemData = -1
    For i = 0 To ctl.ListCount - 1
        If h = ctl.ItemData(i) Then
            LookupItemData = i
            Exit Function
        End If
    Next
End Function
''@E LookupItemData

''@B LookupItem
Function LookupItem(ctl As Control, sItem As String) As Long
    LookupItem = SendMessageAsStr(ctl.hWnd, LB_FINDSTRING, -1, sItem)
End Function
''@E LookupItem

''@B VBWindowFromPoint
Function VBWindowFromPoint(ByVal X, ByVal Y) ' As SysInt
#If Win32 Then
    VBWindowFromPoint = WindowFromPointXY(X, Y)
#Else
    VBWindowFromPoint = WindowFromPointYX(Y, X)
#End If
End Function
''@E VBWindowFromPoint

Function VBChildWindowFromPoint(ByVal hWnd, ByVal X, ByVal Y) ' As SysInt
#If Win32 Then
    VBChildWindowFromPoint = ChildWindowFromPointXY(hWnd, X, Y)
#Else
    VBChildWindowFromPoint = ChildWindowFromPointYX(hWnd, Y, X)
#End If
End Function

''@B GetInstExeName
Function GetInstExeName(ByVal hInst) As String
    Dim sName As String, cName As Integer
    sName = String$(cMaxPath + 1, 0)
    cName = GetModuleFileName(hInst, sName, cMaxPath + 1)
#If Win32 And afDebug Then
    If cName = 0 Then
         BugMessage "Error: " & Err.LastDllError
    End If
#End If
    GetInstExeName = GetFileBaseExt(Left$(sName, cName))
End Function
''@E GetInstExeName

''@B GetInstExePath
Function GetInstExePath(ByVal hInst) As String
    Dim sName As String, cName As Integer
    sName = String$(cMaxPath + 1, 0)
    cName = GetModuleFileName(hInst, sName, cMaxPath)
    GetInstExePath = Left$(sName, cName)
#If Win32 And afDebug Then
    If cName = 0 Then
        BugMessage "Error: " & Err.LastDllError
    End If
#End If
End Function
''@E GetInstExePath

''@B VBGetClassName
Function VBGetClassName(ByVal hWnd) As String
    Dim sName As String, cName As Integer
    BugAssert hWnd <> hNull
    sName = String$(41, 0)
    cName = GetClassName(hWnd, sName, 41)
    VBGetClassName = Left$(sName, cName)
End Function
''@E VBGetClassName

''@B GetWndExeName
Function GetWndExeName(ByVal hWnd) As String
    BugAssert hWnd <> hNull
    GetWndExeName = GetInstExeName(GetWindowData( _
                                   hWnd, GWD_HINSTANCE))
End Function
''@E GetWndExeName

''@B GetWndExePath
Function GetWndExePath(ByVal hWnd) As String
    BugAssert hWnd <> hNull
    GetWndExePath = GetInstExePath(GetWindowData(hWnd, GWD_HINSTANCE))
End Function
''@E GetWndExePath

''@B GetWndOwner
Function GetWndOwner(ByVal hWnd) As String
    Dim hwndOwner ' As SysInt
    BugAssert hWnd <> hNull
    hwndOwner = GetWindow(hWnd, GW_OWNER)
    If hwndOwner <> hNull Then
        GetWndOwner = VBGetWindowTextLine(hwndOwner)
    Else
        GetWndOwner = sEmpty
    End If
End Function
''@E GetWndOwner

''@B VBFindWindow
Function VBFindWindow(Optional vClass As Variant, _
                      Optional vTitle As Variant) ' As SysInt
    If IsMissing(vClass) Then vClass = vbNullString
    If IsMissing(vTitle) Then vTitle = vbNullString
    VBFindWindow = FindWindow(vClass, vTitle)
End Function
''@E VBFindWindow

''@B VBGetWindowText
Function VBGetWindowText(ByVal hWnd) As String
    Dim c As Integer, s As String
    c = GetWindowTextLength(hWnd)
    If c <= 0 Then Exit Function
    s = String$(c, 0)
    c = GetWindowText(hWnd, s, c + 1)
    VBGetWindowText = s
End Function
''@E VBGetWindowText

''@B VBGetWindowTextLine
Function VBGetWindowTextLine(ByVal hWnd) As String
    Dim sTitle As String, cTitle As Integer
    sTitle = VBGetWindowText(hWnd)
    ' Chop off end of multiline captions
    cTitle = InStr(sTitle, sCr)
    VBGetWindowTextLine = IIf(cTitle, Left$(sTitle, cTitle), sTitle)
End Function
''@E VBGetWindowTextLine

Function GetInstance(ByVal hWnd) ' As SysInt
    GetInstance = GetWindowData(hWnd, GWD_HINSTANCE)
End Function


Function VBFindTopWindow(sClass As String, sTitle As String) ' As SysInt
                       
    ' Assume fail for easy exit
    VBFindTopWindow = hNull
    If sClass = sEmpty And sTitle = sEmpty Then Exit Function

    ' Get first sibling to start iterating top level windows
    Dim fClass As Boolean, fTitle As Boolean
    Dim hWnd ' As SysInt
    hWnd = GetWindow(GetDesktopWindow(), GW_CHILD)
    Do While hWnd <> hNull
        
        ' Check class
        fClass = True
        If sClass <> sEmpty Then
            fClass = (StrComp(sClass, VBGetClassName(hWnd)) = 0)
        End If
        
        ' Check title
        fTitle = True
        If sTitle <> sEmpty Then
            fTitle = (VBGetWindowText(hWnd) Like sTitle)
        End If

        ' Check success
        If fClass And fTitle Then
            VBFindTopWindow = hWnd
            Exit Function
        End If

        ' Get next sibling
        hWnd = GetWindow(hWnd, GW_HWNDNEXT)
    Loop

End Function

''@B ChangeStyleBit
Sub ChangeStyleBit(hWnd, f As Boolean, afNew As Long)
    Dim af As Long
    af = GetWindowLong(hWnd, GWL_STYLE)
    If f Then
        af = af Or afNew
    Else
        af = af And (Not afNew)
    End If
    Call SetWindowLong(hWnd, GWL_STYLE, af)
    ' Redraw so that change will "take"
    Call SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, _
                      SWP_NOZORDER Or SWP_NOSIZE Or _
                      SWP_NOMOVE Or SWP_DRAWFRAME)
End Sub
''@E ChangeStyleBit

Sub ChangeExtStyleBit(hWnd, f As Boolean, afNew As Long)
    Dim af As Long
    af = GetWindowLong(hWnd, GWL_EXSTYLE)
    If f Then
        af = af Or afNew
    Else
        af = af And (Not afNew)
    End If
    Call SetWindowLong(hWnd, GWL_EXSTYLE, af)
    ' Redraw so that change will "take"
    Call SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, _
                      SWP_NOZORDER Or SWP_NOSIZE Or _
                      SWP_NOMOVE Or SWP_DRAWFRAME)
End Sub
