Attribute VB_Name = "MWinWatch"
Option Explicit
#If Win32 Then
DefLng A-Z
#Else
DefInt A-Z
#End If

'$ Uses DEBUG.BAS

Public nFileCur As Integer
Public fLogFile As Boolean

''@B DoWindow
Public Function DoWindow(ByVal iLevel As Integer, _
                         ByVal hWnd) As Long
    BugAssert hWnd <> hNull
    If iLevel < 0 Then Exit Function ' Ignore desktop window
        
    If fLogFile Then
        ' Write data to log file
        Print #nFileCur, GetWndInfo(hWnd, iLevel)
    Else
        ' Add window title; if none, add bracketed window class
        Static s As String, i As Integer
        s = VBGetWindowTextLine(hWnd)
        If s = sEmpty Then s = "[" & VBGetClassName(hWnd) & "]"
        If IsWindowVisible(hWnd) Or FWatch.chkInvisible.Value Then
            ' Update outline control
            With FWatch.outWin
                .AddItem s                  ' Add title
                i = .ListCount - 1
                .Indent(i) = iLevel + 1     ' Set outline level
                .ItemData(i) = hWnd         ' Store window handle
            End With
        End If
    End If
    ' Always successful
    DoWindow = hNull

End Function
''@E DoWindow

Public Function GetWndInfo(hWnd, Optional iTab As Variant) As String
    Dim sStart As String, s As String, sTemp As String
    BugAssert hWnd <> hNull
    If IsMissing(iTab) Then iTab = 0
    
    ' Nested starting position
    sStart = Space$(iTab * 4)
    ' Window information
    sTemp = VBGetWindowTextLine(hWnd)
    'sTemp = VBGetWindowText(hWnd)
    If sTemp = sEmpty Then sTemp = "[none]"
    s = sStart & "Title: " & sTemp & sCrLf
    s = s & sStart & "Program: " & GetWndExeName(hWnd) & sCrLf
    s = s & sStart & "Class: " & VBGetClassName(hWnd) & sCrLf
    s = s & sStart & "View: " & GetWndView(hWnd) & sCrLf
    s = s & sStart & "Style: " & GetWndStyle(hWnd) & sCrLf
    sTemp = GetWndOwner(hWnd)
    If sTemp <> sEmpty Then
        s = s & sStart & "Owner: " & sTemp & sCrLf
    End If

    GetWndInfo = s

End Function


    ''@B GetWndStyle
Private Function GetWndStyle(hWnd) As String
    Dim af As Long, s As String
    BugAssert hWnd <> hNull

    ' Get normal style
    af = GetWindowLong(hWnd, GWL_STYLE)
    If af And WS_BORDER Then s = s & "Border "
    If af And WS_CAPTION Then s = s & "Caption "
    If af And WS_CHILD Then s = s & "Child "
    ''@E GetWndStyle...
    If af And WS_CLIPCHILDREN Then s = s & "ClipChildren "
    If af And WS_CLIPSIBLINGS Then s = s & "ClipSiblings "
    If af And WS_DLGFRAME Then s = s & "DlgFrame "
    If af And WS_GROUP Then s = s & "Group "
    If af And WS_HSCROLL Then s = s & "HScroll "
    If af And WS_MAXIMIZEBOX Then s = s & "MaximizeBox "
    If af And WS_MINIMIZEBOX Then s = s & "MinimizeBox "
    If af And WS_POPUP Then s = s & "Popup "
    If af And WS_SYSMENU Then s = s & "SysMenu "
    If af And WS_TABSTOP Then s = s & "TabStop "
    If af And WS_THICKFRAME Then s = s & "ThickFrame "
    If af And WS_VSCROLL Then s = s & "VScroll "

    ' Get extended style
    ''@B GetExStyle
    af = GetWindowLong(hWnd, GWL_EXSTYLE)
    ''@E GetExStyle
    If af And WS_EX_DLGMODALFRAME Then s = s & "DlgModalFrame "
    If af And WS_EX_NOPARENTNOTIFY Then s = s & "NoParentNotify "
    If af And WS_EX_TOPMOST Then s = s & "Topmost "
    If af And WS_EX_ACCEPTFILES Then s = s & "AcceptFiles "
    If af And WS_EX_TRANSPARENT Then s = s & "Transparent "

    GetWndStyle = s

End Function

''@B GetWndView
Public Function GetWndView(hWnd) As String
    Dim s As String
    BugAssert hWnd <> hNull
    s = IIf(IsWindowVisible(hWnd), "Visible ", "Invisible ")
    s = s & IIf(IsWindowEnabled(hWnd), "Enabled", "Disabled ")
    s = s & IIf(IsZoomed(hWnd), "Zoomed ", sEmpty)
    s = s & IIf(IsIconic(hWnd), "Iconic ", sEmpty)
    GetWndView = s
End Function
''@E GetWndView
'
